﻿package vfl.as3.roteiro {
	
	import flash.utils.setTimeout;
	import flash.utils.clearTimeout;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.events.EventDispatcher;
	import vfl.as3.util.StringUtils;
	import flash.utils.getDefinitionByName;
	import flash.media.SoundTransform;	
	
	import com.greensock.TweenLite;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;	
		
	public class Roteiro extends EventDispatcher
	{
		public static const DEBUG = false;
		public var indice 	= -1;
		public var roteiro_	= null;
		public var acao 	 	= null;
		public var container 	= null;
		public var root_		= null;
		
		public var pontoChave	= 0;
		
		public var textoFalas	= "";
		
		// Acoes.
		public var legenda 	= null;
		public var fala		= null;
		public var dublagem = null;
		
		// Dublagem.
		public var importarDublagem 		= false;
		public var prefixoClasseDublagem  	= "";
		public var contagemFala 			= 1;
		public var volumeDublagem			: SoundTransform = null;
		
		// Timeouts.
		public var acaooToi 			= -1;
		public var tentarDeNovoToi		= -1;
		
		public function Roteiro(pRoteiro		: Array,									
								pContainer		: DisplayObject,
								pRoot			: MovieClip = null)
		{
			indice  	= -1;
			roteiro_ 	= pRoteiro;
			
			container	= pContainer;
			root_		= pRoot;
			
			volumeDublagem = new SoundTransform(1);
		}
		
		public function SetVolumeDublagem(vol: Number)
		{
			volumeDublagem = new SoundTransform(vol);
		}
		
		public function Iniciar(capituloDestino = -1)
		{
			contagemFala	= 1;
			
			// Iniciar em um capítulo específico.
			if (capituloDestino != -1)
			{
				capituloDestino--;
				var cont = 0;
				for (var i = 0; i < roteiro_.length; i++)
				{
					if (cont == capituloDestino) break;
					else
					{					
						indice++;
						if (roteiro_[i].tipo == "pausa") cont++;					
					}
				}				
			}
			
			Continuar();
		}
		
		public function ProximaAcao()
		{			
			// Roteiro encerrado.
			if (roteiro_ == null) return ;
			
			// Finaliza a ação anterior.
			if (indice > -1)
			{
				switch (roteiro_[indice].tipo)
				{
					case "fala"		: ExpressaoPadrao(); break;
					case "expressao": ExpressaoPadrao(); break;				
				}
			}
									
			// Avança para a próxima ação.
			clearTimeout(acaooToi);
			acaooToi = -1;
			indice++;
			
			if (indice < roteiro_.length)
			{
				if (DEBUG) trace("[Roteiro.as] Acao atual " + roteiro_[indice].tipo);
				
				if (roteiro_[indice].ignorar)
				{
					if (DEBUG) trace("[Roteiro.as] Ignorando acao atual!");
					ProximaAcao();
					return ;
				}
				
				switch (roteiro_[indice].tipo)
				{
					case "fala":
						if (roteiro_[indice].dublagem != null)
							dublagem = CriarDublagem(roteiro_[indice].dublagem, roteiro_[indice].recorte_dublagem);
						else 
						{							
							if (importarDublagem)
							{								
								var ClassReference, className;
								try
								{
									AtualizarContagemFala();
									className = prefixoClasseDublagem + (contagemFala < 10 ? "0" + contagemFala : contagemFala) + ".mp3";
									//trace("Importando " + className);
									ClassReference = getDefinitionByName(className) as Class;
									dublagem = CriarDublagem(ClassReference, roteiro_[indice].recorte_dublagem);
								}
								catch(error:Error) {
									try
									{
										AtualizarContagemFala();
										className = prefixoClasseDublagem + "" + contagemFala + ".mp3";
										//trace("Importando " + className);
										ClassReference = getDefinitionByName(className) as Class;
										dublagem = CriarDublagem(ClassReference, roteiro_[indice].recorte_dublagem);
									}
									catch(error:Error) {
										trace("Error catch: " + error);    
										dublagem = null;
									}
								}
							}
							else dublagem = null;
						}
												
						// Inicia a fala.
						fala 	= CriarFala(roteiro_[indice].fala);												
						if (dublagem != null) fala.SetTempoTotal(dublagem.GetTempoTotal());
												
						// Inicia a legenda.
						var textoFala_str 	= fala.GetTexto();
						textoFala_str 		= textoFala_str.replace(/\|/,"");
						textoFala_str 		= textoFala_str.replace(/\|/,"");
						textoFala_str 		= textoFala_str.replace(/\|/,"");						
						textoFalas 		   += " - <b>" + roteiro_[indice].personagem.nome + "</b>: " + 
									  			textoFala_str + "<br/><br/>";
						legenda	= CriarLegenda(	fala.GetTexto(),
												roteiro_[indice].personagem.cor);
						
						// Inicia os componentes.
						if (dublagem != null) dublagem.Iniciar();
						fala.Iniciar();
						legenda.Exibir();
						
						if (dublagem != null) legenda.SetTempoTotal(dublagem.GetTempoTotal());
						
						AtualizarContagemFala();
						dispatchEvent(new RoteiroEvento( RoteiroEvento.INICIO_ACAO, 
											 			 RoteiroEvento.TIPO_FALA,
														 {texto: fala.GetTexto()}));
						
						break;
					
					case "pausa":		
						dispatchEvent(new RoteiroEvento(RoteiroEvento.FIM_CAPITULO, "", {}));
						break;
						
					case "expressao":
						ExecutarExpressao2(roteiro_[indice].expressao);
						acaooToi = setTimeout(ProximaAcao, roteiro_[indice].duracao);
						break;
						
					case "funcao":
						roteiro_[indice].funcao();
						if ((roteiro_[indice].parar == undefined) || 
							(roteiro_[indice].parar != true))
						{
							if (DEBUG) trace("[Roteiro.as] funcao ProximaAcao()");							
							ProximaAcao();
						}
						break;
						
					case "intervalo":
						acaooToi = setTimeout(ProximaAcao, roteiro_[indice].tempo);
						break;
				}
			}
			else
			{
			}
		}
		
		public function ReiniciarCapitulo()
		{
			indice = pontoChave;
			Continuar();
		}
		
		public function Continuar()
		{
			if (DEBUG) trace("[Roteiro.as] Continuar()" );
			
			textoFalas = "";			
			pontoChave = indice;
			dispatchEvent(new RoteiroEvento(RoteiroEvento.INICIO_CAPITULO, "", {}));
			
			ProximaAcao();
		}
		
		public function Parar()
		{
			if (acaooToi != -1) clearTimeout(acaooToi);
			if (tentarDeNovoToi != -1) clearTimeout(tentarDeNovoToi);
						
			if (legenda)
			{
				legenda.Encerrar();
				legenda.removeEventListener(LegendaEvento.FIM, FimLegenda);
				legenda = null;
			}
			
			if (fala)
			{
				fala.Encerrar();
				fala.removeEventListener(FalaEvento.INICIO					, FalaInicio);
				fala.removeEventListener(FalaEvento.PALAVRA_CHAVE_INICIO	, FalaPalavraChaveInicio);			
				fala.removeEventListener(FalaEvento.PALAVRA_CHAVE_FIM		, FalaPalavraChaveFim);	
				fala.removeEventListener(FalaEvento.FIM						, FalaFim);						
				fala.removeEventListener(FalaEventoProgresso.PROGRESSO		, FalaProgresso);	
			}
			
			if (dublagem)
			{
				dublagem.Encerrar();
				dublagem.removeEventListener(DublagemEvento.INICIO				, DublagemInicio);
				dublagem.removeEventListener(DublagemEvento.FIM					, DublagemFim);
				dublagem.removeEventListener(DublagemEvento.INICIO_FALA			, FalaDublagem);
				dublagem.removeEventListener(DublagemEvento.PAUSA_FALA			, PausaDublagem);				
			}
			
			Roteiro.EncerrarImagens();
		}
		
		public function Encerrar()
		{
			Parar();
			
			roteiro_	= null;
			acao 	 	= null;
			container 	= null;
			root_		= null;
		}
		
		//-------------------------------------------------------
		//	Opcções de dublagem.
		//-------------------------------------------------------		
		public function AtualizarContagemFala()
		{
			contagemFala = 0;
			for (var i = 0; i <= indice; i++)
			{
				if (roteiro_[i].tipo == "fala") contagemFala++;
			}
		}
		public function ImportarDublagem(pImportarDublagem)
		{
			importarDublagem = pImportarDublagem;
		}
		
		public function SetPrefixoDublagem(pPrefixoDublagem)
		{
			prefixoClasseDublagem = pPrefixoDublagem;
		}
				
		
		//----------------------------------------------------------------------------
		// ACOES.
		
		//-------------------------------------------------------
		//	Legenda.
		//-------------------------------------------------------
		public function CriarLegenda(fala, cor)
		{
			var legenda = new Legenda(	fala,
										container,
										cor);
			if (dublagem == null)
				legenda.addEventListener(LegendaEvento.FIM, FimLegenda);
			return legenda;
		}
		
		public function FimLegenda(evt)
		{
			if (DEBUG) trace("[Roteiro.as] Fim legenda");
			
			if (fala != null)
			{
				fala.removeEventListener(FalaEvento.INICIO				, FalaInicio);
				fala.removeEventListener(FalaEvento.PALAVRA_CHAVE_INICIO, FalaPalavraChaveInicio);			
				fala.removeEventListener(FalaEvento.PALAVRA_CHAVE_FIM	, FalaPalavraChaveFim);	
				fala.removeEventListener(FalaEvento.FIM					, FalaFim);			
				fala.removeEventListener(FalaEventoProgresso.PROGRESSO		, FalaProgresso);	
				fala.Encerrar();
			}
			
			
			if (legenda != null)
			{
				legenda.Encerrar();
			}
			
			fala 	= null;
			legenda = null;
			
			//if (roteiro_[indice].parar != null && roteiro_[indice].parar != "true")
			if (dublagem == null)
			{
				if (DEBUG) trace("[Roteiro.as] FimLegenda agendando proxima acao.");
				acaooToi = setTimeout(ProximaAcao, (roteiro_[indice].intervalo != null ? roteiro_[indice].intervalo : 500));
			}
		}
		
		//---------------------------------------------------------
		//	Dublagem.
		//---------------------------------------------------------
		public function CriarDublagem(classeSom, recorteDublagem)
		{
			var dublagem = new Dublagem(classeSom, volumeDublagem, recorteDublagem)
			dublagem.addEventListener(DublagemEvento.INICIO					, DublagemInicio);
			dublagem.addEventListener(DublagemEvento.FIM					, DublagemFim);
			dublagem.addEventListener(DublagemEvento.INICIO_FALA			, FalaDublagem);
			dublagem.addEventListener(DublagemEvento.PAUSA_FALA				, PausaDublagem);			
			return dublagem;
		}
		
		public function DublagemInicio(evt)
		{
			if ( roteiro_[indice].personagem.movie )
				roteiro_[indice].personagem.movie.gotoAndPlay("Fala");						
		}
		
		public function DublagemFim(evt)
		{						
			//trace("DublagemFim");
			FimLegenda(null);
			if ( roteiro_[indice].personagem.movie )
				roteiro_[indice].personagem.movie.gotoAndStop("Normal");		
			PersonagemCalar(false);
			
			dublagem.removeEventListener(DublagemEvento.INICIO				, DublagemInicio);
			dublagem.removeEventListener(DublagemEvento.FIM					, DublagemFim);
			dublagem.removeEventListener(DublagemEvento.INICIO_FALA			, FalaDublagem);
			dublagem.removeEventListener(DublagemEvento.PAUSA_FALA			, PausaDublagem);	
			dublagem.Encerrar();
			dublagem = null;
			
			if (DEBUG) trace("[Roteiro.as] DublagemFim agendando proxima acao.");
			acaooToi = setTimeout(ProximaAcao, (roteiro_[indice].intervalo != null ? roteiro_[indice].intervalo : 500));
		}
		
		public function FalaDublagem(evt)
		{
			PersonagemFalar();
		}
		
		public function PersonagemFalar(tentar = true)
		{
			if (roteiro_[indice].personagem.movie && 
				roteiro_[indice].personagem.movie.cabeca_mc && 
				roteiro_[indice].personagem.movie.cabeca_mc.boca_mc)
				roteiro_[indice].personagem.movie.cabeca_mc.boca_mc.gotoAndPlay("Fala");
			else 
			{
				if (tentar) tentarDeNovoToi = setTimeout(PersonagemFalar, 100, false);
				else tentarDeNovoToi = -1;
			}
		}
		
		public function PausaDublagem(evt)
		{
			PersonagemCalar();
		}
		
		public function PersonagemCalar(tentar = true)
		{
			if (roteiro_[indice].personagem.movie && 
				roteiro_[indice].personagem.movie.cabeca_mc && 
				roteiro_[indice].personagem.movie.cabeca_mc.boca_mc)
				roteiro_[indice].personagem.movie.cabeca_mc.boca_mc.gotoAndStop("Normal");
			else
			{
				if (tentar) tentarDeNovoToi = setTimeout(PersonagemCalar, 100, false);
				else tentarDeNovoToi = -1;
			}
		}
		
		//---------------------------------------------------------
		//	Fala.
		//---------------------------------------------------------
		public function CriarFala(fala)
		{
			var fala = new Fala(fala)
			fala.addEventListener(FalaEvento.INICIO					, FalaInicio);
			fala.addEventListener(FalaEvento.PALAVRA_CHAVE_INICIO	, FalaPalavraChaveInicio);
			fala.addEventListener(FalaEvento.PALAVRA_CHAVE_FIM		, FalaPalavraChaveFim);				
			fala.addEventListener(FalaEvento.FIM					, FalaFim);			
			fala.addEventListener(FalaEventoProgresso.PROGRESSO		, FalaProgresso);						
			return fala;
		}
		
		public function FalaInicio(evt)
		{
			if (DEBUG) trace("[Roteiro.as] FalaInicio " + roteiro_[indice].tipo + " " + roteiro_[indice].fala );
			
			// A dublagem é que define movimentação de personagem e boca.
			// A fala só definirá isso se a dublagem não existir.
			if (dublagem == null && roteiro_[indice].personagem.movie)
				roteiro_[indice].personagem.movie.gotoAndPlay("Fala");
		}
		
		public function FalaPalavraChaveInicio(evt)
		{
			if (DEBUG) trace("   atingiu a palavra-chave '" + evt.palavra + "' " + evt.tipo + " " + evt.identificador);
			switch (evt.tipo)
			{
				case "F":
					if (evt.palavra != "") legenda.DestacarPalavra(evt.inicio, evt.fim, roteiro_[indice].personagem.cor);				
					ExecutarFuncao(evt.identificador);				
					break;
				
				case "E":
					ExecutarExpressao(evt.identificador);
					break;
					
				case "EC":
					ExecutarExpressao2(evt.identificador);
					break;					
			}
			
		}
		
		public function FalaPalavraChaveFim(evt)
		{
			if (DEBUG) trace("[Roteiro.as] Palavra-chave fim" + evt);
			//legenda.RemoverDestaque();
			switch (evt.tipo)
			{				
				case "E":
					FalaPadrao();
					break;
					
				case "EC":
					FalaPadrao();
					break;					
			}			
		}
		
		public function FalaProgresso(evt)
		{
			dispatchEvent(new RoteiroEvento( RoteiroEvento.PROGRESSO_ACAO, 
											 RoteiroEvento.TIPO_FALA,
											{progresso: evt.progresso}));
		}
		
		public function FalaFim(evt)
		{
			if (DEBUG) trace("[Roteiro.as] Fala fim");
			
			// A dublagem é que define movimentação de personagem e boca.
			// A fala só definirá isso se a dublagem não existir.
			if (dublagem == null && roteiro_[indice].personagem.movie)
				roteiro_[indice].personagem.movie.gotoAndPlay("Normal");
				
			dispatchEvent(new RoteiroEvento( RoteiroEvento.FIM_ACAO, 
											 RoteiroEvento.TIPO_FALA,
											{}));		
			
		}
		
		
		//-----------------------------------------------------------
		//	Funções e expressões.
		//-----------------------------------------------------------
		public function ExecutarFuncao(identificador)
		{
			if (StringUtils.isNumeric(identificador))
			{
				trace("[Roteiro] Utilize o nome da função ao inves de numeros.");
			}
			else
			{
				if (root_ != null)
					root_[identificador]();
			}
		}
		
		public function ExecutarExpressao(identificador, tentarDeNovo = true)
		{
			if (roteiro_[indice].personagem.movie && 
				roteiro_[indice].personagem.movie.cabeca_mc)
				roteiro_[indice].personagem.movie.cabeca_mc.gotoAndPlay(identificador);					
			else
			{
				if (tentarDeNovo) tentarDeNovoToi = setTimeout(ExecutarExpressao, 100, identificador, false);
				else tentarDeNovoToi = -1;
			}
		}
		
		public function ExecutarExpressao2(identificador)
		{
			if (roteiro_[indice].personagem.movie)
				roteiro_[indice].personagem.movie.gotoAndPlay(identificador);
			//roteiro_[indice].personagem.movie.cabeca_mc.gotoAndPlay(identificador);					
			ExecutarExpressao(identificador);
		}

		public function ExpressaoPadrao()
		{
			if (roteiro_[indice].personagem.movie && 
				roteiro_[indice].personagem.movie.currentLabel != "Normal")
				roteiro_[indice].personagem.movie.gotoAndPlay("Normal");
				
			if (roteiro_[indice].personagem.movie && 
				roteiro_[indice].personagem.movie.cabeca_mc != undefined && 
				roteiro_[indice].personagem.movie.cabeca_mc.currentLabel != "Normal")
				roteiro_[indice].personagem.movie.cabeca_mc.gotoAndPlay("Normal");				
		}
		
		public function FalaPadrao()
		{
			if (roteiro_[indice].personagem.movie && roteiro_[indice].personagem.movie.currentLabel != "Fala") roteiro_[indice].personagem.movie.gotoAndPlay("Fala");					
			if (roteiro_[indice].personagem.movie && roteiro_[indice].personagem.movie.cabeca_mc && roteiro_[indice].personagem.movie.cabeca_mc.currentLabel != "Fala") roteiro_[indice].personagem.movie.cabeca_mc.gotoAndPlay("Fala");											
		}
		
		//---------------------------------------------------------------------------
		public static var indiceImagens	: uint		= 0;
		public static var imagens		: Array 	= null;
		public static var container_mc	: MovieClip	= null;
		public static var imagemInterval: int		= -1;
		
		public static function ExibirImagens(pImagens	: Array,
											 pContainer	: MovieClip)
		{			
			indiceImagens= 0;
			imagens		 = pImagens;
			container_mc = pContainer;
			
			// Limpa o container.
			while (container_mc.numChildren > 0) container_mc.removeChildAt(0);
			container_mc.overlay 	 = null;
			container_mc.imagemAtual = null;
						
			// Inicia a exibição.
			if (imagens.length > 0) 
			{							
				// Cria o overlay.
				var overlay_mc = new MovieClip();
				overlay_mc.graphics.beginFill(0);
				overlay_mc.graphics.drawRect(0,0, 700, 500);
				overlay_mc.alpha = 0;
				container_mc.addChild(overlay_mc);
				container_mc.overlay = overlay_mc;
			
				container_mc.mouseEnabled  = true;				
				container_mc.mouseChildren = true;
			
				// Overlay surge.
				TweenLite.to(overlay_mc, 0.5, {alpha: 0.7, onComplete: ExibirImagem});
			}
			
		}
		
		private static function ExibirImagem()
		{
			/*
			if (container_mc.imagemAtual == null)
				ExibirImagem2();
				
			else
				TweenLite.to(container_mc.imagemAtual, 0.5, {alpha: 0, onComplete: ExibirImagem2});		
				*/
			if (container_mc.imagemAtual != null)
				TweenLite.to(container_mc.imagemAtual, 0.5, {alpha: 0});		
				
			ExibirImagem2();								
		}
		
		private static function ExibirImagem2()
		{
			/*
			if (container_mc.imagemAtual != null)
			{
				container_mc.removeChild(container_mc.imagemAtual);
			}
			*/
			
			var imagem = imagens[indiceImagens];
			
			var borda  				= (imagem.borda 	!= null ? imagem.borda : 8);
			var rotacao  			= (imagem.rotacao 	!= null ? imagem.rotacao : 0);
			var tempo				= (imagem.tempo 	!= null ? imagem.tempo : 3000);	
			
			var imagem_bd			= new imagem.imagem(10, 10);
			var imagem_bmp 		   	= new Bitmap(imagem_bd);
			imagem_bmp.smoothing 	= true;
			
			if (imagem_bmp.height > 400)
			{
				var p = 400 / imagem_bmp.height ;
				imagem_bmp.height *= p;
				imagem_bmp.width  *= p;
				
			}
			
			var imagemContainer_mc 	= new MovieClip();			
			
			var overlay_mc 			= container_mc.overlay;
			
			imagemContainer_mc.graphics.beginFill(0xFFFFFF);
			imagemContainer_mc.graphics.drawRect(-imagem_bmp.width/2 - borda, 
												 -imagem_bmp.height/2 - borda, 
												 imagem_bmp.width + (2*borda), 
												 imagem_bmp.height + (2*borda));
			imagemContainer_mc.addChild(imagem_bmp);
			imagem_bmp.x = -imagem_bmp.width/2 ;
			imagem_bmp.y = -imagem_bmp.height/2;
			
			container_mc.imagemAtual = imagemContainer_mc;
			
			container_mc.addChild(imagemContainer_mc);
			
			imagemContainer_mc.x = overlay_mc.width/2;
			imagemContainer_mc.y = (overlay_mc.height-80)/2;
			imagemContainer_mc.alpha = 0;
			
			imagemContainer_mc.rotation = rotacao;
			
			TweenLite.to(imagemContainer_mc, 0.5, {alpha: 1});
			imagemInterval = setTimeout(ProximaImagem, tempo);
		}
		
		public static function ProximaImagem()
		{
			imagemInterval = -1;
			indiceImagens++;
			if (indiceImagens < imagens.length) ExibirImagem();
			else
			{
				container_mc.mouseEnabled  = false;				
				container_mc.mouseChildren = false;
				
				TweenLite.to(container_mc.overlay		, 0.5, {alpha: 0});
				if (container_mc.imagemAtual != null)
					TweenLite.to(container_mc.imagemAtual	, 0.5, {alpha: 0});				
			}
		}
		
		public static function EncerrarImagens()
		{
			if (imagemInterval != -1) 				clearTimeout(imagemInterval);
			if (container_mc != null)
			{
				if (container_mc.imagemAtual != null)	TweenLite.killTweensOf(container_mc.imagemAtual);
				if (container_mc.overlay != null)		TweenLite.killTweensOf(container_mc.overlay );
				while (container_mc.numChildren > 0) container_mc.removeChildAt(0);
			}
		}						
	}
}