﻿
package vfl.as3.util
{
	public class ColorUtil
	{
		public static function HexaToRGB( hexa )
		{
			return [ExtractRed(hexa), ExtractGreen(hexa), ExtractBlue(hexa)];
		}
		
		public static function ExtractRed(c:uint):uint 
		{
			return (( c >> 16 ) & 0xFF);		
		}
				 
		public static function ExtractGreen(c:uint):uint 
		{
			return ( (c >> 8) & 0xFF );
		}
		
		public static function ExtractBlue(c:uint):uint 
		{
			return ( c & 0xFF );
		}
		
		public static function CombineRGB(r:uint,g:uint,b:uint):uint 
		{
			return ( ( r << 16 ) | ( g << 8 ) | b );		
		}		
		
		public static function DisplayInHex(c:uint):String 
		{
			var r:String = ColorUtil.ExtractRed(c).toString(16).toUpperCase();
			var g:String = ColorUtil.ExtractGreen(c).toString(16).toUpperCase();
			var b:String = ColorUtil.ExtractBlue(c).toString(16).toUpperCase();
			
			var hs:String   = "";			
			var zero:String = "0";
			
			if (r.length == 1) r = zero.concat(r);
			if (g.length == 1) g = zero.concat(g);
			if (b.length == 1) b = zero.concat(b);
			
			hs = r + g + b;			
			return hs;
		}		
	}
}