﻿package vfl.as3.util 
{		
	import flash.utils.clearInterval;
	import flash.utils.setInterval;
	
	import flash.utils.getTimer;
	import flash.events.EventDispatcher;

	public class MyTimer extends EventDispatcher
	{
		private var startTime;
		private var currentTime;
		
		private var countdownSeconds;
		private var timeoutId;
		
		private var lastSeconds;
		
		private var paused_;
		private var pauseStartTime;
		private var pausedTime;
		
		public function MyTimer( pCountdownSeconds = 0 ) 
		{
			startTime 	= 0;
			currentTime	= 0;
			
			lastSeconds = 0;
			
			countdownSeconds = pCountdownSeconds;
			timeoutId		 = -1;
			
			paused_ = false;
			pausedTime = 0;
		}
		
		public function Start()
		{
			Stop();
			
			startTime = getTimer();
			pausedTime= 0;
			
			if (timeoutId != -1) clearInterval(timeoutId);
			timeoutId = setInterval(CheckEvents, 100);
			
			Update();
		}
		
		public function Stop()
		{
			if (timeoutId != -1) 
			{
				clearInterval(timeoutId);
				timeoutId = -1;
			}
		}
		
		public function Reset()
		{
			Start();
		}
		
		public function Update()
		{
			if (!paused_)
			{
				currentTime = getTimer() - startTime - pausedTime;
				if (countdownSeconds != 0) currentTime = ((countdownSeconds*1000)+10) - currentTime;
				if (currentTime < 0) currentTime = 0;
			}
		}
		
		public function CheckEvents()
		{
			var seconds = GetTotalSeconds();
			
			if (seconds == 0 && countdownSeconds != 0)	
			{
				Stop();
				dispatchEvent(new MyTimerEvent(MyTimerEvent.TIMER_END, this));
			}
			if (lastSeconds != seconds) dispatchEvent(new MyTimerEvent(MyTimerEvent.TIMER_CHANGE, this));
			
			lastSeconds = seconds;
		}
		
		//-------------------------------------------
		public function Pause()
		{
			pauseStartTime = getTimer();
			paused_ = true;
		}
		
		public function Continue()
		{
			pausedTime += getTimer() - pauseStartTime;
			paused_ = false;
		}
		
		//-------------------------------------------
		public function AddSeconds(s)
		{
			startTime += s * 1000;
		}
		
		public function AddMinutes(m)
		{
			AddSeconds(m * 60);
		}		
		
		public function AddHours(h)
		{
			AddMinutes(h * 60);
		}				
		
		//-------------------------------------------

		public function GetSeconds()
		{
			return Math.floor(GetTotalSeconds()%60);
		}
		
		public function GetMinutes()
		{
			//trace(GetTotalMinutes());
			return Math.floor(GetTotalMinutes()%60);
		}
		
		public function GetHours()
		{
			return GetTotalHours();
		}		

		//-------------------------------------------
		public function GetMileseconds()
		{
			Update();
			return currentTime;
		}
		
		public function GetTotalSeconds()
		{
			Update();			
			return Math.floor(currentTime/1000);
		}
		
		public function GetTotalMinutes()
		{
			var seconds = GetTotalSeconds();
			return Math.floor(seconds/60);
		}
		
		public function GetTotalHours()
		{
			var minutes = GetMinutes();
			return Math.floor(minutes/60);
		}		
		
		//-----------------------------------------
		public function To2Digits( v )
		{
			return (v > 9 ? v : "0" + v);
		}
		
		override public function toString(): String
		{
			return To2Digits(GetHours()) + ":" + To2Digits(GetMinutes()) + ":" + To2Digits(GetSeconds());
		}
	}
}